#include<linux/module.h>

#define ARRAY_NUMBER_OF_ELEMENTS 10
#define STRING_NUMBER_OF_ELEMENTS 40

static char foo[STRING_NUMBER_OF_ELEMENTS];
static int array[ARRAY_NUMBER_OF_ELEMENTS];
static int number_of_elements = 0;

module_param_string(foostring,foo,STRING_NUMBER_OF_ELEMENTS,0644);
MODULE_PARM_DESC(foostring, "A char array parameter");
module_param_array(array,int,&number_of_elements,0644);
MODULE_PARM_DESC(array, "An array parameter");

static int __init parammod_init(void)
{
	int i;
	printk(KERN_INFO"Module parameter:\n");

	printk(KERN_INFO"foo value: %s\n",foo);

	printk(KERN_INFO"array values: ");
	for(i=0;i<number_of_elements;i++)
		printk(KERN_CONT"%d\n",array[i]);
	
	return 0;
}

static void __exit parammod_exit(void)
{
	int i;
	printk(KERN_INFO "Module parameter:\n");

	printk(KERN_INFO "foo value: %s\n",foo);
	
	printk(KERN_INFO"array values: ");
	for(i=0;i<number_of_elements;i++)
		printk(KERN_CONT"%d\n",array[i]);
}

module_init(parammod_init);
module_exit(parammod_exit);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Arkadiusz Chrobot <a.chrobot@tu.kielce.pl>");
MODULE_DESCRIPTION("Kernel module with char array (string) and array parameters.");
MODULE_VERSION("1.0");

